"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
const model_1 = require("../class/model");
function Field(...args) {
    // Determine the target and parameters to be passed to the FieldDescriptor based
    // on arguments supplied to the @Field decorator, this allows the decorator to
    // be used as either @Field or @Field(params)
    let target;
    let name;
    let params = {};
    let propertyDescriptor;
    args.length === 1
        ? [params] = args
        : [target, name, propertyDescriptor] = args;
    function Field(target, name, propertyDescriptor) {
        if (propertyDescriptor)
            throw new Error("Cannot use the Primary decorator on a method");
        const model = model_1.Model.descriptor(target, true);
        const field = model.field(name);
        field.assign(params);
        const valueType = Reflect.getMetadata("design:type", target, name);
        field.designType = valueType;
    }
    if (target)
        return Field(target, name, propertyDescriptor);
    else
        return Field;
}
exports.Field = Field;
//# sourceMappingURL=field.js.map